
"
We load functions that will 
automatically do the estimation for us.
"

restart
writeFP=(uPar,theDir)->(
     fpFile:= openOut (theDir|"/final_parameters");
     fpFile << toString(#uPar) << endl << endl;
     for i from 0 to #uPar-1 do (
	  fpFile << (uPar_i)|" "|toString(0) << endl
	  );
     close fpFile)

runBertini=(theDir)->(
     run("cd "|theDir|"; "|"bertini"))

matrixForm=(bertiniSolution)->(
     bS:=bertiniSolution;
     mF=matrix{
	  {bS_0_0+ii*bS_0_1,
	       bS_1_0+ii*bS_1_1,
	       bS_2_0+ii*bS_2_1},
	  {bS_3_0+ii*bS_3_1,
	       bS_4_0+ii*bS_4_1,
	       bS_5_0+ii*bS_5_1},
	  {bS_6_0+ii*bS_6_1,
	       bS_7_0+ii*bS_7_1,
	       bS_8_0+ii*bS_8_1}};
     return mF)


getLL=(yourM,yP)->(
     yP_0*log(abs(yourM_(0,0)))+yP_1*log(abs(yourM_(0,1)))+yP_2*log(abs(yourM_(0,2)))+
     yP_3*log(abs(yourM_(1,0)))+yP_4*log(abs(yourM_(1,1)))+yP_5*log(abs(yourM_(1,2)))+
     yP_6*log(abs(yourM_(2,0)))+yP_7*log(abs(yourM_(2,1)))+yP_8*log(abs(yourM_(2,2)))
     )



collectASolution=(readFileLoop1,numCoord,keepCoord)->(
     justASol:={};
     readFileLoop1=drop(readFileLoop1,1);--drops an empty line
     for j from 0 to numCoord-1 do (
	  if member(j,keepCoord) then (
	       oneCoord:=select("[0-9.+-]+e[0-9+-]+",first(readFileLoop1));
     	       justASol=append(justASol,{value(oneCoord_0),value(oneCoord_1)});
     	       readFileLoop1=drop(readFileLoop1,1)) else (
	  readFileLoop1=drop(readFileLoop1,1)));--drops lagrange
     return justASol)


readBertiniFile=(nameFile,numCoord,keepCoord)->(
     nameFile="/"|nameFile;
     readFile:=lines get (theDir|nameFile);
     outputNumSols:=value(readFile_0);--reads first line
     readFile=drop(readFile,1);--drops first line
     getAllSol:={};
     for i from 0 to outputNumSols-1 do(
     	  cAS=collectASolution(readFile,numCoord,keepCoord);
     	  getAllSol=append(getAllSol,cAS);
     	  readFile=drop(readFile,1+numCoord););
     return getAllSol)


prettyOutput33=(getAllSol)->(
     numSols:=#getAllSol;
     prettyOut:=for i from 0 to numSols-1 list     
     (i,getLL(matrixForm(getAllSol_i),userParameters),
	  matrixForm(getAllSol_i),
	  eigenvalues matrixForm(getAllSol_i));
     return prettyOut     )

mleR2v33=(userParameters,theDir,solutionType)->(
     numCoord:=1+length(userParameters);
     keepCoord:=for i from 0 to 9-1 list i;
     writeFP(userParameters,theDir);
     runBertini(theDir);
     getAllSol:=readBertiniFile(solutionType,numCoord,keepCoord);
     prettyOut:=prettyOutput33(getAllSol);
     return prettyOut)

"
Now that we have loaded our functions,
we are ready to solve our MLE problem.
l
The user must input 
1) the directory that this M2 file and bertini files are located as a string.
2) a list of 9 integers.
3) the type of solutions the user is interested in as a string. 
"

--Examples--
theDir="/Users/MacMath/Desktop/implement33/"
theDir=currentDirectory()
userParameters=for i from 0 to 9-1 list random(ZZ)+random(ZZ)
solType1="real_finite_solutions"
solType2="finite_solutions"
solType3="singular_solutions"
solType4="nonsingular_solutions"

outputCriticalPoints=mleR2v33(userParameters,theDir,solType4)
netList outputCriticalPoints
"
The output is a list whose entries are sequences of 4 elements. 
The first element is the solution number starting at 0.
The second element is the log-likelihood of the absolute value of the solutions coordinates.
The third element is the the solution in the form of a 3x3 matrix. 
The fourth element is a list of eigenvalues of the solution. 
"

"We can study other solution types without 
rerunning our computations by using the 
readBertiniFile command. 
This command takes as its input 
1) solution type as a string
2) 10
3) {0,1,2,3,4,5,6,7,8}
"
rfs=readBertiniFile(solType1,10,for i from 0 to 8 list i)
prettyOutput33(oo)
netList oo








